import {isDefined} from './utils/index'

class EventBus {
    eventList = {}
    constructor(){
    }
    on(type:string,fn){
        if(!isDefined(type)) return new Error('type must a string type')
        if(!this.eventList[type]) this.eventList[type] = []
        this.eventList[type].push(fn)
        return true
    }
    emit(type:string){
        if(!isDefined(type)) return false
        if(this.eventList[type]){
            this.eventList[type].forEach(fn => {
                fn()
            });
        }
        return true
    }
    empty(type:string){
        if(!isDefined(type)) return false
        if(this.eventList[type]){
            this.eventList[type] = null
        }
    }
    
}

export const eventBus =  new EventBus()